# This file was automatically generated by SWIG (https://www.swig.org).
# Version 4.3.0
#
# Do not make changes to this file unless you know what you are doing - modify
# the SWIG interface file instead.

"""
SWIG wrapper and helper around libavrdude

The module defines all things necessary to perform the
same operations as the CLI AVRDUDE program, and exports
it to Python.

Invoke like

import swig_avrdude as ad

The following global variables are available in `ad.cvar`:

`ad.cvar.version`  - str, read-only
`ad.cvar.progname` - str, for messages
`ad.cvar.progbuf`  - str, spaces same length as `progname`
`ad.cvar.verbose`  - int, message verbosity (0 ... 5)
`ad.cvar.quell_progress` - int, message supression (0 ... 2)
`ad.cvar.ovsigck`  - int, override signature and some other checks (0 ... 1)
"""

from sys import version_info as _swig_python_version_info
# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _swig_avrdude
else:
    import _swig_avrdude

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "this":
            set(self, name, value)
        elif name == "thisown":
            self.this.own(value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


MSG_EXT_ERROR = _swig_avrdude.MSG_EXT_ERROR

MSG_ERROR = _swig_avrdude.MSG_ERROR

MSG_WARNING = _swig_avrdude.MSG_WARNING

MSG_INFO = _swig_avrdude.MSG_INFO

MSG_NOTICE = _swig_avrdude.MSG_NOTICE

MSG_NOTICE2 = _swig_avrdude.MSG_NOTICE2

MSG_DEBUG = _swig_avrdude.MSG_DEBUG

MSG_TRACE = _swig_avrdude.MSG_TRACE

MSG_TRACE2 = _swig_avrdude.MSG_TRACE2

MSG2_PROGNAME = _swig_avrdude.MSG2_PROGNAME

MSG2_FUNCTION = _swig_avrdude.MSG2_FUNCTION

MSG2_FILELINE = _swig_avrdude.MSG2_FILELINE

MSG2_TYPE = _swig_avrdude.MSG2_TYPE

MSG2_INDENT1 = _swig_avrdude.MSG2_INDENT1

MSG2_INDENT2 = _swig_avrdude.MSG2_INDENT2

MSG2_FLUSH = _swig_avrdude.MSG2_FLUSH

MSG2_LEFT_MARGIN = _swig_avrdude.MSG2_LEFT_MARGIN


def set_msg_callback(PyFunc):
    r"""set_msg_callback(PyObject * PyFunc)"""
    return _swig_avrdude.set_msg_callback(PyFunc)

def set_progress_callback(PyFunc):
    r"""set_progress_callback(PyObject * PyFunc)"""
    return _swig_avrdude.set_progress_callback(PyFunc)
class AVRPART(object):
    r"""Proxy of C avrpart struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    desc = property(_swig_avrdude.AVRPART_desc_get, doc=r"""desc : p.q(const).char""")
    id = property(_swig_avrdude.AVRPART_id_get, doc=r"""id : p.q(const).char""")
    variants = property(_swig_avrdude.AVRPART_variants_get, doc=r"""variants : LISTID""")
    parent_id = property(_swig_avrdude.AVRPART_parent_id_get, doc=r"""parent_id : p.q(const).char""")
    family_id = property(_swig_avrdude.AVRPART_family_id_get, doc=r"""family_id : p.q(const).char""")
    prog_modes = property(_swig_avrdude.AVRPART_prog_modes_get, doc=r"""prog_modes : int""")
    signature = property(_swig_avrdude.AVRPART_signature_get, doc=r"""signature : a(3).unsigned char""")
    usbpid = property(_swig_avrdude.AVRPART_usbpid_get, doc=r"""usbpid : unsigned short""")
    mem = property(_swig_avrdude.AVRPART_mem_get, doc=r"""mem : LISTID""")
    mem_alias = property(_swig_avrdude.AVRPART_mem_alias_get, doc=r"""mem_alias : LISTID""")
    config_file = property(_swig_avrdude.AVRPART_config_file_get, doc=r"""config_file : p.q(const).char""")
    lineno = property(_swig_avrdude.AVRPART_lineno_get, doc=r"""lineno : int""")

    def __init__(self):
        r"""__init__(AVRPART self) -> AVRPART"""
        _swig_avrdude.AVRPART_swiginit(self, _swig_avrdude.new_AVRPART())
    __swig_destroy__ = _swig_avrdude.delete_AVRPART

# Register AVRPART in _swig_avrdude:
_swig_avrdude.AVRPART_swigregister(AVRPART)
cvar = _swig_avrdude.cvar
version = cvar.version
partdesc = cvar.partdesc
pgmid = cvar.pgmid

class AVRMEM(object):
    r"""Proxy of C avrmem struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    desc = property(_swig_avrdude.AVRMEM_desc_get, doc=r"""desc : p.q(const).char""")
    type = property(_swig_avrdude.AVRMEM_type_get, doc=r"""type : Memtype""")
    paged = property(_swig_avrdude.AVRMEM_paged_get, doc=r"""paged : bool""")
    size = property(_swig_avrdude.AVRMEM_size_get, doc=r"""size : int""")
    page_size = property(_swig_avrdude.AVRMEM_page_size_get, doc=r"""page_size : int""")
    num_pages = property(_swig_avrdude.AVRMEM_num_pages_get, doc=r"""num_pages : int""")
    initval = property(_swig_avrdude.AVRMEM_initval_get, doc=r"""initval : int""")
    bitmask = property(_swig_avrdude.AVRMEM_bitmask_get, doc=r"""bitmask : int""")
    buf = property(_swig_avrdude.AVRMEM_buf_get, _swig_avrdude.AVRMEM_buf_set, doc=r"""buf : p.unsigned char""")

    def get(self, len, offset=0):
        r"""m.get(len: int, offset: int = 0) => return bytes; Read from memory buffer"""
        return _swig_avrdude.AVRMEM_get(self, len, offset)

    def put(self, _in, offset=0):
        r"""m.put(in: bytes, len: int, offset: int = 0) => return len; Copy to memory buffer, set ALLOCATED tag"""
        return _swig_avrdude.AVRMEM_put(self, _in, offset)

    def clear(self, len, offset=0, value=255):
        r"""m.clear(len, offset, value=0xFF) => return len; Clear memory buffer range, and ALLOCATED tag"""
        return _swig_avrdude.AVRMEM_clear(self, len, offset, value)

    def __init__(self):
        r"""__init__(AVRMEM self) -> AVRMEM"""
        _swig_avrdude.AVRMEM_swiginit(self, _swig_avrdude.new_AVRMEM())
    __swig_destroy__ = _swig_avrdude.delete_AVRMEM

# Register AVRMEM in _swig_avrdude:
_swig_avrdude.AVRMEM_swigregister(AVRMEM)
class AVRMEM_ALIAS(object):
    r"""Proxy of C avrmem_alias struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    desc = property(_swig_avrdude.AVRMEM_ALIAS_desc_get, doc=r"""desc : p.q(const).char""")
    aliased_mem = property(_swig_avrdude.AVRMEM_ALIAS_aliased_mem_get, doc=r"""aliased_mem : p.AVRMEM""")

    def __init__(self):
        r"""__init__(AVRMEM_ALIAS self) -> AVRMEM_ALIAS"""
        _swig_avrdude.AVRMEM_ALIAS_swiginit(self, _swig_avrdude.new_AVRMEM_ALIAS())
    __swig_destroy__ = _swig_avrdude.delete_AVRMEM_ALIAS

# Register AVRMEM_ALIAS in _swig_avrdude:
_swig_avrdude.AVRMEM_ALIAS_swigregister(AVRMEM_ALIAS)

def avr_initmem(p):
    r"""avr_initmem(AVRPART p) -> int"""
    return _swig_avrdude.avr_initmem(p)
CONNTYPE_PARALLEL = _swig_avrdude.CONNTYPE_PARALLEL

CONNTYPE_SERIAL = _swig_avrdude.CONNTYPE_SERIAL

CONNTYPE_USB = _swig_avrdude.CONNTYPE_USB

CONNTYPE_SPI = _swig_avrdude.CONNTYPE_SPI

CONNTYPE_LINUXGPIO = _swig_avrdude.CONNTYPE_LINUXGPIO

class PROGRAMMER(object):
    r"""Proxy of C programmer struct."""

    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr
    id = property(_swig_avrdude.PROGRAMMER_id_get, doc=r"""id : LISTID""")
    desc = property(_swig_avrdude.PROGRAMMER_desc_get, doc=r"""desc : p.q(const).char""")
    prog_modes = property(_swig_avrdude.PROGRAMMER_prog_modes_get, doc=r"""prog_modes : int""")
    conntype = property(_swig_avrdude.PROGRAMMER_conntype_get, doc=r"""conntype : Conntype""")
    baudrate = property(_swig_avrdude.PROGRAMMER_baudrate_get, doc=r"""baudrate : int""")
    usbvid = property(_swig_avrdude.PROGRAMMER_usbvid_get, doc=r"""usbvid : int""")
    usbpid = property(_swig_avrdude.PROGRAMMER_usbpid_get, doc=r"""usbpid : LISTID""")
    ispdelay = property(_swig_avrdude.PROGRAMMER_ispdelay_get, doc=r"""ispdelay : int""")
    bitclock = property(_swig_avrdude.PROGRAMMER_bitclock_get, doc=r"""bitclock : double""")
    type = property(_swig_avrdude.PROGRAMMER_type_get, doc=r"""type : a(PGM_TYPELEN).char""")

    def initpgm(self):
        r"""initpgm(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_initpgm(self)

    def initialize(self, p):
        r"""initialize(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_initialize(self, p)

    def setup(self):
        r"""setup(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_setup(self)

    def teardown(self):
        r"""teardown(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_teardown(self)

    def parseextparams(self, xparams):
        r"""parseextparams(PROGRAMMER self, LISTID const xparams) -> int"""
        return _swig_avrdude.PROGRAMMER_parseextparams(self, xparams)

    def parseexitspecs(self, s):
        r"""parseexitspecs(PROGRAMMER self, char const * s) -> int"""
        return _swig_avrdude.PROGRAMMER_parseexitspecs(self, s)

    def open(self, port):
        r"""open(PROGRAMMER self, char const * port) -> int"""
        return _swig_avrdude.PROGRAMMER_open(self, port)

    def close(self):
        r"""close(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_close(self)

    def enable(self, p):
        r"""enable(PROGRAMMER self, AVRPART p)"""
        return _swig_avrdude.PROGRAMMER_enable(self, p)

    def disable(self):
        r"""disable(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_disable(self)

    def read_sib(self, p):
        r"""read_sib(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_read_sib(self, p)

    def powerup(self):
        r"""powerup(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_powerup(self)

    def powerdown(self):
        r"""powerdown(PROGRAMMER self)"""
        return _swig_avrdude.PROGRAMMER_powerdown(self)

    def chip_erase(self, p):
        r"""chip_erase(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_chip_erase(self, p)

    def term_keep_alive(self, p):
        r"""term_keep_alive(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_term_keep_alive(self, p)

    def end_programming(self, p):
        r"""end_programming(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_end_programming(self, p)

    def print_parms(self, f_parms):
        r"""print_parms(PROGRAMMER self, FILE * f_parms)"""
        return _swig_avrdude.PROGRAMMER_print_parms(self, f_parms)

    def set_vtarget(self, vtarg_in):
        r"""set_vtarget(PROGRAMMER self, double vtarg_in) -> int"""
        return _swig_avrdude.PROGRAMMER_set_vtarget(self, vtarg_in)

    def get_vtarget(self):
        r"""get_vtarget(PROGRAMMER self) -> int"""
        return _swig_avrdude.PROGRAMMER_get_vtarget(self)

    def set_varef(self, chan, varef_in):
        r"""set_varef(PROGRAMMER self, unsigned int chan, double varef_in) -> int"""
        return _swig_avrdude.PROGRAMMER_set_varef(self, chan, varef_in)

    def get_varef(self, chan):
        r"""get_varef(PROGRAMMER self, unsigned int chan) -> int"""
        return _swig_avrdude.PROGRAMMER_get_varef(self, chan)

    def set_fosc(self, fosc_in):
        r"""set_fosc(PROGRAMMER self, double fosc_in) -> int"""
        return _swig_avrdude.PROGRAMMER_set_fosc(self, fosc_in)

    def get_fosc(self):
        r"""get_fosc(PROGRAMMER self) -> int"""
        return _swig_avrdude.PROGRAMMER_get_fosc(self)

    def set_sck_period(self, sck_in):
        r"""set_sck_period(PROGRAMMER self, double sck_in) -> int"""
        return _swig_avrdude.PROGRAMMER_set_sck_period(self, sck_in)

    def get_sck_period(self):
        r"""get_sck_period(PROGRAMMER self) -> int"""
        return _swig_avrdude.PROGRAMMER_get_sck_period(self)

    def write_byte_cached(self, p, m, addr, value):
        r"""write_byte_cached(PROGRAMMER self, AVRPART p, AVRMEM m, unsigned long addr, unsigned char value) -> int"""
        return _swig_avrdude.PROGRAMMER_write_byte_cached(self, p, m, addr, value)

    def read_byte_cached(self, p, m, addr, value):
        r"""read_byte_cached(PROGRAMMER self, AVRPART p, AVRMEM m, unsigned long addr, unsigned char * value) -> int"""
        return _swig_avrdude.PROGRAMMER_read_byte_cached(self, p, m, addr, value)

    def chip_erase_cached(self, p):
        r"""chip_erase_cached(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_chip_erase_cached(self, p)

    def page_erase_cached(self, p, m, baseaddr):
        r"""page_erase_cached(PROGRAMMER self, AVRPART p, AVRMEM m, unsigned int baseaddr) -> int"""
        return _swig_avrdude.PROGRAMMER_page_erase_cached(self, p, m, baseaddr)

    def readonly(self, p, m, addr):
        r"""readonly(PROGRAMMER self, AVRPART p, AVRMEM m, unsigned int addr) -> int"""
        return _swig_avrdude.PROGRAMMER_readonly(self, p, m, addr)

    def flush_cache(self, p):
        r"""flush_cache(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_flush_cache(self, p)

    def reset_cache(self, p):
        r"""reset_cache(PROGRAMMER self, AVRPART p) -> int"""
        return _swig_avrdude.PROGRAMMER_reset_cache(self, p)

    def __init__(self):
        r"""__init__(PROGRAMMER self) -> PROGRAMMER"""
        _swig_avrdude.PROGRAMMER_swiginit(self, _swig_avrdude.new_PROGRAMMER())
    __swig_destroy__ = _swig_avrdude.delete_PROGRAMMER

# Register PROGRAMMER in _swig_avrdude:
_swig_avrdude.PROGRAMMER_swigregister(PROGRAMMER)

def init_cx(pgm=None):
    r"""init_cx(PROGRAMMER pgm=None)"""
    return _swig_avrdude.init_cx(pgm)

def init_config():
    r"""init_config() -> int"""
    return _swig_avrdude.init_config()

def cleanup_config():
    r"""cleanup_config()"""
    return _swig_avrdude.cleanup_config()

def read_config(file):
    r"""read_config(char const * file) -> int"""
    return _swig_avrdude.read_config(file)

def lfirst(arg1):
    r"""lfirst(LISTID arg1) -> LNODEID"""
    return _swig_avrdude.lfirst(arg1)

def llast(arg1):
    r"""llast(LISTID arg1) -> LNODEID"""
    return _swig_avrdude.llast(arg1)

def lnext(arg1):
    r"""lnext(LNODEID arg1) -> LNODEID"""
    return _swig_avrdude.lnext(arg1)

def lprev(arg1):
    r"""lprev(LNODEID arg1) -> LNODEID"""
    return _swig_avrdude.lprev(arg1)

def ldata(arg1):
    r"""ldata(LNODEID arg1) -> void *"""
    return _swig_avrdude.ldata(arg1)

def lsize(arg1):
    r"""lsize(LISTID arg1) -> int"""
    return _swig_avrdude.lsize(arg1)

def ldata_programmer(arg1):
    r"""LNODEID -> PROGRAMMER*"""
    return _swig_avrdude.ldata_programmer(arg1)

def ldata_avrpart(arg1):
    r"""LNODEID -> AVRPART*"""
    return _swig_avrdude.ldata_avrpart(arg1)

def ldata_avrmem(arg1):
    r"""LNODEID -> AVRMEM*"""
    return _swig_avrdude.ldata_avrmem(arg1)

def ldata_avrmem_alias(arg1):
    r"""LNODEID -> AVRMEM_ALIAS*"""
    return _swig_avrdude.ldata_avrmem_alias(arg1)

def ldata_string(arg1):
    r"""LNODEID -> str"""
    return _swig_avrdude.ldata_string(arg1)

def avr_locate_mem(p, desc):
    r"""avr_locate_mem(AVRPART p, char const * desc) -> AVRMEM"""
    return _swig_avrdude.avr_locate_mem(p, desc)

def locate_part(parts, partdesc):
    r"""locate_part(LISTID const parts, char const * partdesc) -> AVRPART"""
    return _swig_avrdude.locate_part(parts, partdesc)

def avr_locate_memalias(p, desc):
    r"""avr_locate_memalias(AVRPART p, char const * desc) -> AVRMEM_ALIAS"""
    return _swig_avrdude.avr_locate_memalias(p, desc)

def avr_find_memalias(p, m_orig):
    r"""avr_find_memalias(AVRPART p, AVRMEM m_orig) -> AVRMEM_ALIAS"""
    return _swig_avrdude.avr_find_memalias(p, m_orig)
PM_SPM = _swig_avrdude.PM_SPM

PM_TPI = _swig_avrdude.PM_TPI

PM_ISP = _swig_avrdude.PM_ISP

PM_PDI = _swig_avrdude.PM_PDI

PM_UPDI = _swig_avrdude.PM_UPDI

PM_HVSP = _swig_avrdude.PM_HVSP

PM_HVPP = _swig_avrdude.PM_HVPP

PM_debugWIRE = _swig_avrdude.PM_debugWIRE

PM_JTAG = _swig_avrdude.PM_JTAG

PM_JTAGmkI = _swig_avrdude.PM_JTAGmkI

PM_XMEGAJTAG = _swig_avrdude.PM_XMEGAJTAG

PM_AVR32JTAG = _swig_avrdude.PM_AVR32JTAG

PM_aWire = _swig_avrdude.PM_aWire

PM_Classic = _swig_avrdude.PM_Classic

PM_ALL = _swig_avrdude.PM_ALL


def locate_part_by_signature(parts, sig):
    r"""locate_part_by_signature(LISTID const parts, unsigned char * sig) -> AVRPART"""
    return _swig_avrdude.locate_part_by_signature(parts, sig)

def locate_part_by_signature_pm(parts, sig, prog_modes):
    r"""locate_part_by_signature_pm(LISTID const parts, unsigned char * sig, int prog_modes) -> AVRPART"""
    return _swig_avrdude.locate_part_by_signature_pm(parts, sig, prog_modes)

def locate_programmer_set(programmers, id, setid):
    r"""locate_programmer_set(LISTID const programmers, char const * id, char const ** setid) -> PROGRAMMER"""
    return _swig_avrdude.locate_programmer_set(programmers, id, setid)

def locate_programmer_starts_set(programmers, id, setid, prt):
    r"""locate_programmer_starts_set(LISTID const programmers, char const * id, char const ** setid, AVRPART prt) -> PROGRAMMER"""
    return _swig_avrdude.locate_programmer_starts_set(programmers, id, setid, prt)

def locate_programmer(programmers, configid):
    r"""locate_programmer(LISTID const programmers, char const * configid) -> PROGRAMMER"""
    return _swig_avrdude.locate_programmer(programmers, configid)

def avr_read_mem(pgm, p, mem, v=None):
    r"""avr_read_mem(PROGRAMMER pgm, AVRPART p, AVRMEM mem, AVRPART v=None -> int; v: verify against"""
    return _swig_avrdude.avr_read_mem(pgm, p, mem, v)

def avr_write_mem(*args):
    r"""avr_write_mem(PROGRAMMER pgm, AVRPART p, AVRMEM mem, int size, int auto_erase) -> int; write entire memory region from `mem` buffer"""
    return _swig_avrdude.avr_write_mem(*args)

def avr_write_byte(pgm, p, mem, addr, data):
    r"""avr_write_byte(PROGRAMMER pgm, AVRPART p, AVRMEM mem, int addr, byte data) -> int"""
    return _swig_avrdude.avr_write_byte(pgm, p, mem, addr, data)
FMT_ERROR = _swig_avrdude.FMT_ERROR

FMT_AUTO = _swig_avrdude.FMT_AUTO

FMT_SREC = _swig_avrdude.FMT_SREC

FMT_IHEX = _swig_avrdude.FMT_IHEX

FMT_RBIN = _swig_avrdude.FMT_RBIN

FMT_IMM = _swig_avrdude.FMT_IMM

FMT_EEGG = _swig_avrdude.FMT_EEGG

FMT_HEX = _swig_avrdude.FMT_HEX

FMT_DEC = _swig_avrdude.FMT_DEC

FMT_OCT = _swig_avrdude.FMT_OCT

FMT_BIN = _swig_avrdude.FMT_BIN

FMT_ELF = _swig_avrdude.FMT_ELF

FMT_IHXC = _swig_avrdude.FMT_IHXC

FIO_READ = _swig_avrdude.FIO_READ

FIO_WRITE = _swig_avrdude.FIO_WRITE

FIO_READ_FOR_VERIFY = _swig_avrdude.FIO_READ_FOR_VERIFY


def fileio_format(c):
    r"""fileio_format(c: char) -> FILEFMT"""
    return _swig_avrdude.fileio_format(c)

def fileio_fmtstr(format):
    r"""fileio_fmtstr(f: FILEFMT) -> str"""
    return _swig_avrdude.fileio_fmtstr(format)

def fileio_fmtchr(format):
    r"""fileio_fmtchr(f: FILEFMT) -> char"""
    return _swig_avrdude.fileio_fmtchr(format)

def fileio_fmt_autodetect(fname):
    r"""fileio_fmt_autodetect(fname: str) -> FILEFMT"""
    return _swig_avrdude.fileio_fmt_autodetect(fname)

def fileio(oprwv, filename, format, p, memstr, size):
    r"""fileio(oprwv: FIO_OP, filename: str, format: FILEFMT, p: AVRPART, memstr: str, size: int) -> int [size, or -1 on error]"""
    return _swig_avrdude.fileio(oprwv, filename, format, p, memstr, size)

def get_config_table(name):
    r"""get_config_table(name: str) -> list"""
    return _swig_avrdude.get_config_table(name)

